﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using DslModeling = Microsoft.VisualStudio.Modeling;
using DslDiagrams = Microsoft.VisualStudio.Modeling.Diagrams;

namespace NihonUnisys.ObjectER
{
	/// <summary>
	/// Partial class to handle serialization of Schema instance as a root-level XML element.
	/// </summary>
	public partial class SchemaSerializer
	{
		/// <summary>
		/// Public ReadRootElement() method that deserializes a root-level Schema instance from XML.
		/// </summary>
		/// <param name="serializationContext">Serialization context.</param>
		/// <param name="element">In-memory Schema instance that will get the deserialized data.</param>
		/// <param name="reader">XmlReader to read serialized data from.</param>
		/// <param name="schemaResolver">An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).</param>
		public override void ReadRootElement(DslModeling::SerializationContext serializationContext, DslModeling::ModelElement element, global::System.Xml.XmlReader reader, DslModeling::ISchemaResolver schemaResolver)
		{
			#region Check Parameters
			global::System.Diagnostics.Debug.Assert(serializationContext != null);
			if (serializationContext == null)
				throw new global::System.ArgumentNullException("serializationContext");
			global::System.Diagnostics.Debug.Assert(reader != null);
			if (reader == null)
				throw new global::System.ArgumentNullException("reader");
			#endregion
	
			// Version check.
			CheckVersion(serializationContext, reader);
	
			if (!serializationContext.Result.Failed)
			{	// Check to see if schema validation is possible.
				if (schemaResolver != null)
				{
					string targetNamespace = reader.NamespaceURI;
					if (!string.IsNullOrEmpty(targetNamespace))
					{
						global::System.Collections.Generic.IList<string> schemas = schemaResolver.ResolveSchema(targetNamespace);
						if (schemas != null && schemas.Count > 0)
						{
							if (schemas.Count > 1)
							{
								ObjectERSerializationBehaviorSerializationMessages.AmbiguousSchema(serializationContext, reader, targetNamespace, schemas[0]);
							}
							global::System.Xml.Schema.XmlSchemaSet schemaSet = new global::System.Xml.Schema.XmlSchemaSet(reader.NameTable);
							schemaSet.Add(targetNamespace, schemas[0]);
							global::System.Xml.XmlReaderSettings readerSettings = new global::System.Xml.XmlReaderSettings();
							readerSettings.ConformanceLevel = global::System.Xml.ConformanceLevel.Auto;
							readerSettings.ValidationType = global::System.Xml.ValidationType.Schema;
							readerSettings.Schemas = schemaSet;
							ObjectERSerializationBehaviorSchemaValidationCallback validationCallback = new ObjectERSerializationBehaviorSchemaValidationCallback(serializationContext);
							readerSettings.ValidationEventHandler += new global::System.Xml.Schema.ValidationEventHandler(validationCallback.Handler);
							// Wrap the given reader as a validating reader and carry out the normal deserialization.
							using (global::System.Xml.XmlReader validatingReader = global::System.Xml.XmlReader.Create(reader, readerSettings))
							{
								validationCallback.Reader = validatingReader;
								this.Read(serializationContext, element, validatingReader);
							}
							return;
						}
						else
						{
							ObjectERSerializationBehaviorSerializationMessages.NoSchema(serializationContext, reader, targetNamespace);
						}
					}
				}
	
				// No schema information available, carry out the normal deserialization.
				this.Read(serializationContext, element, reader);
			}
		}
		
		/// <summary>
		/// Checks the version of the file being read.
		/// </summary>
		/// <param name="serializationContext">Serialization context.</param>
		/// <param name="reader">Reader for the file being read. The reader is positioned at the open tag of the root element being read.</param>
		private static void CheckVersion(DslModeling::SerializationContext serializationContext, global::System.Xml.XmlReader reader)
		{
			global::System.Version expectedVersion = new global::System.Version(@"1.0.0.0");
			string dslVersionStr = reader.GetAttribute("dslVersion");
			if (dslVersionStr != null)
			{
				try
				{
					global::System.Version actualVersion = new global::System.Version(dslVersionStr);
					if (actualVersion != expectedVersion)
					{
						ObjectERSerializationBehaviorSerializationMessages.VersionMismatch(serializationContext, reader, expectedVersion, actualVersion);
					}
				}
				catch (global::System.ArgumentException)
				{
					ObjectERSerializationBehaviorSerializationMessages.InvalidPropertyValue(serializationContext, reader, "dslVersion", typeof(global::System.Version), dslVersionStr);
				}
				catch (global::System.FormatException)
				{
					ObjectERSerializationBehaviorSerializationMessages.InvalidPropertyValue(serializationContext, reader, "dslVersion", typeof(global::System.Version), dslVersionStr);
				}
				catch (global::System.OverflowException)
				{
					ObjectERSerializationBehaviorSerializationMessages.InvalidPropertyValue(serializationContext, reader, "dslVersion", typeof(global::System.Version), dslVersionStr);
				}
			}
		}
		
		/// <summary>
		/// A utility class to handle schema validation warning/error
		/// </summary>
		private sealed class ObjectERSerializationBehaviorSchemaValidationCallback
		{
			#region Member Variables
			/// <summary>
			/// SerializationContext to store schema validation warning/error.
			/// </summary>
			DslModeling::SerializationContext serializationContext;
			/// <summary>
			/// Reader that generates the schema warning/error.
			/// </summary>
			global::System.Xml.XmlReader reader;
			#endregion
	
			#region Constructor
			/// <summary>
			/// Constructor
			/// </summary>
			/// <param name="serializationContext">SerializationContext to be used to store schema validation warning/error.</param>
			internal ObjectERSerializationBehaviorSchemaValidationCallback(DslModeling::SerializationContext serializationContext)
			{
				global::System.Diagnostics.Debug.Assert(serializationContext != null);
				this.serializationContext = serializationContext;
			}
			#endregion
	
			#region Accessor
			/// <summary>
			/// Sets the reader that generates the schema validation warning/error.
			/// </summary>
			internal global::System.Xml.XmlReader Reader
			{
				[global::System.Diagnostics.DebuggerStepThrough]
				set { this.reader = value; }
			}
			#endregion
	
			#region Callback method
			/// <summary>
			/// Callback to handler schema validation warning/error.
			/// </summary>
			internal void Handler(object sender, global::System.Xml.Schema.ValidationEventArgs e)
			{
				global::System.Diagnostics.Debug.Assert(this.serializationContext != null);
				if (this.serializationContext != null)
					ObjectERSerializationBehaviorSerializationMessages.SchemaValidationError(this.serializationContext, this.reader, e.Message);
			}
			#endregion
		}
	
		/// <summary>
		/// Public WriteRootElement() method that serializes a root-level Schema instance to XML.
		/// </summary>
		/// <param name="serializationContext">Serialization context.</param>
		/// <param name="element">Schema instance that will be serialized.</param>
		/// <param name="writer">XmlWriter to write serialized data to.</param>
		public override void WriteRootElement(DslModeling::SerializationContext serializationContext, DslModeling::ModelElement element, global::System.Xml.XmlWriter writer)
		{
			#region Check Parameters
			global::System.Diagnostics.Debug.Assert(serializationContext != null);
			if (serializationContext == null)
				throw new global::System.ArgumentNullException("serializationContext");
			global::System.Diagnostics.Debug.Assert(element != null);
			if (element == null)
				throw new global::System.ArgumentNullException("element");
			global::System.Diagnostics.Debug.Assert(writer != null);
			if (writer == null)
				throw new global::System.ArgumentNullException("writer");
			#endregion
	
			// Set up root element settings
			DslModeling::RootElementSettings rootElementSettings = new DslModeling::RootElementSettings();
			rootElementSettings.SchemaTargetNamespace = @"http://schemas.microsoft.com/dsltools/ObjectER";
			rootElementSettings.Version = new global::System.Version(@"1.0.0.0");
	
			// Carry out the normal serialization.
			this.Write(serializationContext, element, writer, rootElementSettings);
		}
	}
}

namespace NihonUnisys.ObjectER
{
	/// <summary>
	/// Partial class to handle serialization of ExampleDiagram instance as a root-level XML element.
	/// </summary>
	public partial class ExampleDiagramSerializer
	{
		/// <summary>
		/// Public ReadRootElement() method that deserializes a root-level ExampleDiagram instance from XML.
		/// </summary>
		/// <param name="serializationContext">Serialization context.</param>
		/// <param name="element">In-memory ExampleDiagram instance that will get the deserialized data.</param>
		/// <param name="reader">XmlReader to read serialized data from.</param>
		/// <param name="schemaResolver">An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).</param>
		public override void ReadRootElement(DslModeling::SerializationContext serializationContext, DslModeling::ModelElement element, global::System.Xml.XmlReader reader, DslModeling::ISchemaResolver schemaResolver)
		{
			#region Check Parameters
			global::System.Diagnostics.Debug.Assert(serializationContext != null);
			if (serializationContext == null)
				throw new global::System.ArgumentNullException("serializationContext");
			global::System.Diagnostics.Debug.Assert(reader != null);
			if (reader == null)
				throw new global::System.ArgumentNullException("reader");
			#endregion
	
			// Version check.
			CheckVersion(serializationContext, reader);
	
			if (!serializationContext.Result.Failed)
			{	// Check to see if schema validation is possible.
				if (schemaResolver != null)
				{
					string targetNamespace = reader.NamespaceURI;
					if (!string.IsNullOrEmpty(targetNamespace))
					{
						global::System.Collections.Generic.IList<string> schemas = schemaResolver.ResolveSchema(targetNamespace);
						if (schemas != null && schemas.Count > 0)
						{
							if (schemas.Count > 1)
							{
								ObjectERSerializationBehaviorSerializationMessages.AmbiguousSchema(serializationContext, reader, targetNamespace, schemas[0]);
							}
							global::System.Xml.Schema.XmlSchemaSet schemaSet = new global::System.Xml.Schema.XmlSchemaSet(reader.NameTable);
							schemaSet.Add(targetNamespace, schemas[0]);
							global::System.Xml.XmlReaderSettings readerSettings = new global::System.Xml.XmlReaderSettings();
							readerSettings.ConformanceLevel = global::System.Xml.ConformanceLevel.Auto;
							readerSettings.ValidationType = global::System.Xml.ValidationType.Schema;
							readerSettings.Schemas = schemaSet;
							ObjectERSerializationBehaviorSchemaValidationCallback validationCallback = new ObjectERSerializationBehaviorSchemaValidationCallback(serializationContext);
							readerSettings.ValidationEventHandler += new global::System.Xml.Schema.ValidationEventHandler(validationCallback.Handler);
							// Wrap the given reader as a validating reader and carry out the normal deserialization.
							using (global::System.Xml.XmlReader validatingReader = global::System.Xml.XmlReader.Create(reader, readerSettings))
							{
								validationCallback.Reader = validatingReader;
								this.Read(serializationContext, element, validatingReader);
							}
							return;
						}
						else
						{
							ObjectERSerializationBehaviorSerializationMessages.NoSchema(serializationContext, reader, targetNamespace);
						}
					}
				}
	
				// No schema information available, carry out the normal deserialization.
				this.Read(serializationContext, element, reader);
			}
		}
		
		/// <summary>
		/// Checks the version of the file being read.
		/// </summary>
		/// <param name="serializationContext">Serialization context.</param>
		/// <param name="reader">Reader for the file being read. The reader is positioned at the open tag of the root element being read.</param>
		private static void CheckVersion(DslModeling::SerializationContext serializationContext, global::System.Xml.XmlReader reader)
		{
			global::System.Version expectedVersion = new global::System.Version(@"1.0.0.0");
			string dslVersionStr = reader.GetAttribute("dslVersion");
			if (dslVersionStr != null)
			{
				try
				{
					global::System.Version actualVersion = new global::System.Version(dslVersionStr);
					if (actualVersion != expectedVersion)
					{
						ObjectERSerializationBehaviorSerializationMessages.VersionMismatch(serializationContext, reader, expectedVersion, actualVersion);
					}
				}
				catch (global::System.ArgumentException)
				{
					ObjectERSerializationBehaviorSerializationMessages.InvalidPropertyValue(serializationContext, reader, "dslVersion", typeof(global::System.Version), dslVersionStr);
				}
				catch (global::System.FormatException)
				{
					ObjectERSerializationBehaviorSerializationMessages.InvalidPropertyValue(serializationContext, reader, "dslVersion", typeof(global::System.Version), dslVersionStr);
				}
				catch (global::System.OverflowException)
				{
					ObjectERSerializationBehaviorSerializationMessages.InvalidPropertyValue(serializationContext, reader, "dslVersion", typeof(global::System.Version), dslVersionStr);
				}
			}
		}
		
		/// <summary>
		/// A utility class to handle schema validation warning/error
		/// </summary>
		private sealed class ObjectERSerializationBehaviorSchemaValidationCallback
		{
			#region Member Variables
			/// <summary>
			/// SerializationContext to store schema validation warning/error.
			/// </summary>
			DslModeling::SerializationContext serializationContext;
			/// <summary>
			/// Reader that generates the schema warning/error.
			/// </summary>
			global::System.Xml.XmlReader reader;
			#endregion
	
			#region Constructor
			/// <summary>
			/// Constructor
			/// </summary>
			/// <param name="serializationContext">SerializationContext to be used to store schema validation warning/error.</param>
			internal ObjectERSerializationBehaviorSchemaValidationCallback(DslModeling::SerializationContext serializationContext)
			{
				global::System.Diagnostics.Debug.Assert(serializationContext != null);
				this.serializationContext = serializationContext;
			}
			#endregion
	
			#region Accessor
			/// <summary>
			/// Sets the reader that generates the schema validation warning/error.
			/// </summary>
			internal global::System.Xml.XmlReader Reader
			{
				[global::System.Diagnostics.DebuggerStepThrough]
				set { this.reader = value; }
			}
			#endregion
	
			#region Callback method
			/// <summary>
			/// Callback to handler schema validation warning/error.
			/// </summary>
			internal void Handler(object sender, global::System.Xml.Schema.ValidationEventArgs e)
			{
				global::System.Diagnostics.Debug.Assert(this.serializationContext != null);
				if (this.serializationContext != null)
					ObjectERSerializationBehaviorSerializationMessages.SchemaValidationError(this.serializationContext, this.reader, e.Message);
			}
			#endregion
		}
	
		/// <summary>
		/// Public WriteRootElement() method that serializes a root-level ExampleDiagram instance to XML.
		/// </summary>
		/// <param name="serializationContext">Serialization context.</param>
		/// <param name="element">ExampleDiagram instance that will be serialized.</param>
		/// <param name="writer">XmlWriter to write serialized data to.</param>
		public override void WriteRootElement(DslModeling::SerializationContext serializationContext, DslModeling::ModelElement element, global::System.Xml.XmlWriter writer)
		{
			#region Check Parameters
			global::System.Diagnostics.Debug.Assert(serializationContext != null);
			if (serializationContext == null)
				throw new global::System.ArgumentNullException("serializationContext");
			global::System.Diagnostics.Debug.Assert(element != null);
			if (element == null)
				throw new global::System.ArgumentNullException("element");
			global::System.Diagnostics.Debug.Assert(writer != null);
			if (writer == null)
				throw new global::System.ArgumentNullException("writer");
			#endregion
	
			// Set up root element settings
			DslModeling::RootElementSettings rootElementSettings = new DslModeling::RootElementSettings();
			rootElementSettings.Version = new global::System.Version(@"1.0.0.0");
	
			// Carry out the normal serialization.
			this.Write(serializationContext, element, writer, rootElementSettings);
		}
	}
}

namespace NihonUnisys.ObjectER
{
	/// <summary>
	/// Helper class for serializing and deserializing ObjectER models.
	/// </summary>
	public static partial class ObjectERSerializationHelper
	{
		/// <summary>
		/// Loads a Schema instance into the default partition of the given store, and ignore serialization result.
		/// </summary>
		/// <param name="store">The new Schema instance will be created into the default partition of this store.</param>
		/// <param name="fileName">Name of the file from which the Schema instance will be deserialized.</param>
		/// <param name="schemaResolver">
		/// An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).
		/// If null is passed, schema validation will not be performed.
		/// </param>
		/// <returns>The loaded Schema instance.</returns>
		public static Schema LoadModel(DslModeling::Store store, string fileName, DslModeling::ISchemaResolver schemaResolver)
		{
			#region Check Parameters
			if (store == null) 
				throw new global::System.ArgumentNullException("store");
			#endregion
			
			return ObjectERSerializationHelper.LoadModel(new DslModeling::SerializationResult(), store.DefaultPartition, fileName, schemaResolver);
		}
		
		/// <summary>
		/// Loads a Schema instance into the default partition of the given store.
		/// </summary>
		/// <param name="serializationResult">Stores serialization result from the load operation.</param>
		/// <param name="store">The new Schema instance will be created into the default partition of this store.</param>
		/// <param name="fileName">Name of the file from which the Schema instance will be deserialized.</param>
		/// <param name="schemaResolver">
		/// An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).
		/// If null is passed, schema validation will not be performed.
		/// </param>
		/// <returns>The loaded Schema instance.</returns>
		public static Schema LoadModel(DslModeling::SerializationResult serializationResult, DslModeling::Store store, string fileName, DslModeling::ISchemaResolver schemaResolver)
		{
			#region Check Parameters
			if (store == null) 
				throw new global::System.ArgumentNullException("store");
			#endregion
			
			return ObjectERSerializationHelper.LoadModel(serializationResult, store.DefaultPartition, fileName, schemaResolver);
		}
	
		/// <summary>
		/// Loads a Schema instance.
		/// </summary>
		/// <param name="serializationResult">Stores serialization result from the load operation.</param>
		/// <param name="partition">Partition in which the new Schema instance will be created.</param>
		/// <param name="fileName">Name of the file from which the Schema instance will be deserialized.</param>
		/// <param name="schemaResolver">
		/// An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).
		/// If null is passed, schema validation will not be performed.
		/// </param>
		/// <returns>The loaded Schema instance.</returns>
		public static Schema LoadModel(DslModeling::SerializationResult serializationResult, DslModeling::Partition partition, string fileName, DslModeling::ISchemaResolver schemaResolver)
		{
			#region Check Parameters
			if (serializationResult == null)
				throw new global::System.ArgumentNullException("serializationResult");
			if (partition == null)
				throw new global::System.ArgumentNullException("partition");
			if (string.IsNullOrEmpty(fileName))
				throw new global::System.ArgumentNullException("fileName");
			#endregion
		
			// Ensure there is a transaction for this model to Load in.
			if (!partition.Store.TransactionActive)
			{
				throw new global::System.InvalidOperationException(global::NihonUnisys.ObjectER.ObjectER.SingletonResourceManager.GetString("MissingTransaction"));
			}
			
			// Set up MonikerResolver for ObjectER.
			ObjectERSerializationHelper.SetupMonikerResolver(partition.Store);
	
			Schema modelRoot = null;
			DslModeling::DomainClassXmlSerializer modelRootSerializer = ObjectERSerializationHelper.Directory.GetSerializer(Schema.DomainClassId);
			global::System.Diagnostics.Debug.Assert(modelRootSerializer != null, "Cannot find serializer for Schema!");
			if (modelRootSerializer != null)
			{
				using (global::System.IO.FileStream fileStream = global::System.IO.File.OpenRead(fileName))
				{
					using (DslModeling::Transaction t = partition.Store.TransactionManager.BeginTransaction("Load Model from " + fileName, true))
					{
						DslModeling::SerializationContext serializationContext = new DslModeling::SerializationContext(ObjectERSerializationHelper.Directory, fileStream.Name, serializationResult);
						// Ensure there is some content in the file.  Blank (or almost blank, to account for encoding header bytes, etc.)
						// files will cause a new root element to be created and returned. 
						if (fileStream.Length > 5)
						{
							global::System.Xml.XmlReaderSettings settings = new global::System.Xml.XmlReaderSettings();
							// settings.IgnoreComments = true;
							// settings.IgnoreWhitespace = true;
							try
							{
								using (global::System.Xml.XmlReader reader = global::System.Xml.XmlReader.Create(fileStream, settings))
								{
									reader.MoveToContent();
									modelRoot = modelRootSerializer.TryCreateInstance(serializationContext, reader, partition) as Schema;
									if (modelRoot != null && !serializationResult.Failed)
									{
										// Note: the actual instance we get back from TryCreateInstance() can be of a derived type of Schema,
										// so we need to find the correct serializer instance to deserialize the element properly.
										DslModeling::DomainClassXmlSerializer instanceSerializer = ObjectERSerializationHelper.Directory.GetSerializer(modelRoot.GetDomainClass().Id);
										global::System.Diagnostics.Debug.Assert(instanceSerializer != null, "Cannot find serializer for " + modelRoot.GetDomainClass().Name + "!");
										instanceSerializer.ReadRootElement(serializationContext, modelRoot, reader, schemaResolver);
									}
								}
	
							}
							catch (global::System.Xml.XmlException xEx)
							{
								DslModeling::SerializationUtilities.AddMessage(
									serializationContext,
									DslModeling::SerializationMessageKind.Error,
									xEx
								);
							}
						}
				
						if(modelRoot == null && !serializationResult.Failed)
						{
							// create model root if it doesn't exist.
							modelRoot = new global::NihonUnisys.ObjectER.Schema(partition);
						}
						if (t.IsActive)
							t.Commit();
					} // End Inner Tx
				}
			}
			return modelRoot;
		}
	
		/// <summary>
		/// Saves the given model root to the given file, with default encoding (UTF-8), and optional properties with default value will not
		/// be written out.
		/// </summary>
		/// <param name="serializationResult">Stores serialization result from the save operation.</param>
		/// <param name="modelRoot">Schema instance to be saved.</param>
		/// <param name="fileName">Name of the file in which the Schema instance will be saved.</param>
		public static void SaveModel(DslModeling::SerializationResult serializationResult, Schema modelRoot, string fileName)
		{
			ObjectERSerializationHelper.SaveModel(serializationResult, modelRoot, fileName, global::System.Text.Encoding.UTF8, false);
		}
		
		/// <summary>
		/// Saves the given model to the given file, with default encoding (UTF-8).
		/// </summary>
		/// <param name="serializationResult">Stores serialization result from the save operation.</param>
		/// <param name="modelRoot">Schema instance to be saved.</param>
		/// <param name="fileName">Name of the file in which the Schema instance will be saved.</param>
		/// <param name="writeOptionalPropertiesWithDefaultValue">Whether optional properties with default value will be saved.</param>
		public static void SaveModel(DslModeling::SerializationResult serializationResult, Schema modelRoot, string fileName, bool writeOptionalPropertiesWithDefaultValue)
		{
			ObjectERSerializationHelper.SaveModel(serializationResult, modelRoot, fileName, global::System.Text.Encoding.UTF8, writeOptionalPropertiesWithDefaultValue);
		}
	
		/// <summary>
		/// Saves the given model root to the given file, with specified encoding.
		/// </summary>
		/// <param name="serializationResult">Stores serialization result from the save operation.</param>
		/// <param name="modelRoot">Schema instance to be saved.</param>
		/// <param name="fileName">Name of the file in which the Schema instance will be saved.</param>
		/// <param name="encoding">Encoding to use when saving the Schema instance.</param>
		/// <param name="writeOptionalPropertiesWithDefaultValue">Whether optional properties with default value will be saved.</param>
		[global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters")]
		public static void SaveModel(DslModeling::SerializationResult serializationResult, Schema modelRoot, string fileName, global::System.Text.Encoding encoding, bool writeOptionalPropertiesWithDefaultValue)
		{
			#region Check Parameters
			if (serializationResult == null)
				throw new global::System.ArgumentNullException("serializationResult");
			if (modelRoot == null)
				throw new global::System.ArgumentNullException("modelRoot");
			if (string.IsNullOrEmpty(fileName))
				throw new global::System.ArgumentNullException("fileName");
			#endregion
	
			if (serializationResult.Failed)
				return;
	
			using (global::System.IO.MemoryStream newFileContent = InternalSaveModel(serializationResult, modelRoot, fileName, encoding, writeOptionalPropertiesWithDefaultValue))
			{
				if (!serializationResult.Failed && newFileContent != null)
				{	// Only write the content if there's no error encountered during serialization.
					using (global::System.IO.FileStream fileStream = new global::System.IO.FileStream(fileName, global::System.IO.FileMode.Create, global::System.IO.FileAccess.Write, global::System.IO.FileShare.None))
					{
						using (global::System.IO.BinaryWriter writer = new global::System.IO.BinaryWriter(fileStream, encoding))
						{
							writer.Write(newFileContent.ToArray());
						}
					}
				}
			}
		}
		
		/// <summary>
		/// Saves the given model root as a in-memory stream.
		/// This is a helper used by SaveModel() and SaveModelAndDiagram(). When saving the model and the diagram together, we want to make sure that 
		/// both can be saved without error before writing the content to disk, so we serialize the model into a in-memory stream first.
		/// </summary>
		/// <param name="serializationResult">Stores serialization result from the save operation.</param>
		/// <param name="modelRoot">Schema instance to be saved.</param>
		/// <param name="fileName">Name of the file in which the Schema instance will be saved.</param>
		/// <param name="encoding">Encoding to use when saving the Schema instance.</param>
		/// <param name="writeOptionalPropertiesWithDefaultValue">Whether optional properties with default value will be saved.</param>
		/// <returns>In-memory stream containing the serialized Schema instance.</returns>
		private static global::System.IO.MemoryStream InternalSaveModel(DslModeling::SerializationResult serializationResult, Schema modelRoot, string fileName, global::System.Text.Encoding encoding, bool writeOptionalPropertiesWithDefaultValue)
		{
			#region Check Parameters
			global::System.Diagnostics.Debug.Assert(serializationResult != null);
			global::System.Diagnostics.Debug.Assert(modelRoot != null);
			global::System.Diagnostics.Debug.Assert(!serializationResult.Failed);
			#endregion
			
			global::System.IO.MemoryStream newFileContent = new global::System.IO.MemoryStream();
			
			// MonikerResolver shouldn't be required in Save operation, so not calling SetupMonikerResolver() here.
			DslModeling::DomainClassXmlSerializer modelRootSerializer = ObjectERSerializationHelper.Directory.GetSerializer(modelRoot.GetDomainClass().Id);
			global::System.Diagnostics.Debug.Assert(modelRootSerializer != null, "Cannot find serializer for " + modelRoot.GetDomainClass().Name + "!");
			if (modelRootSerializer != null)
			{
				DslModeling::SerializationContext serializationContext = new DslModeling::SerializationContext(ObjectERSerializationHelper.Directory, fileName, serializationResult);
				serializationContext.WriteOptionalPropertiesWithDefaultValue = writeOptionalPropertiesWithDefaultValue;
				global::System.Xml.XmlWriterSettings settings = new global::System.Xml.XmlWriterSettings();
				settings.Indent = true;
				settings.Encoding = encoding;
				using (global::System.IO.StreamWriter streamWriter = new global::System.IO.StreamWriter(newFileContent, encoding))
				{
					using (global::System.Xml.XmlWriter writer = global::System.Xml.XmlWriter.Create(streamWriter, settings))
					{
						modelRootSerializer.WriteRootElement(serializationContext, modelRoot, writer);
					}
				}
			}
			return newFileContent;
		}
	
		/// <summary>
		/// Loads a Schema instance and its associated diagram file into the default partition of the given store, and ignore serialization result.
		/// </summary>
		/// <param name="store">The new Schema instance will be created into the default partition of this store.</param>
		/// <param name="modelFileName">Name of the file from which the Schema instance will be deserialized.</param>
		/// <param name="diagramFileName">Name of the file from which the ExampleDiagram instance will be deserialized.</param>
		/// <param name="schemaResolver">
		/// An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).
		/// If null is passed, schema validation will not be performed.
		/// </param>
		/// <returns>The loaded Schema instance.</returns>
		public static Schema LoadModelAndDiagram(DslModeling::Store store, string modelFileName, string diagramFileName, DslModeling::ISchemaResolver schemaResolver)
		{
			return ObjectERSerializationHelper.LoadModelAndDiagram(new DslModeling::SerializationResult(), store, modelFileName, diagramFileName, schemaResolver);
		}
		
		/// <summary>
		/// Loads a Schema instance and its associated diagram file into the default partition of the given store.
		/// </summary>
		/// <param name="serializationResult">Stores serialization result from the load operation.</param>
		/// <param name="store">The new Schema instance will be created into the default partition of this store.</param>
		/// <param name="modelFileName">Name of the file from which the Schema instance will be deserialized.</param>
		/// <param name="diagramFileName">Name of the file from which the ExampleDiagram instance will be deserialized.</param>
		/// <param name="schemaResolver">
		/// An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).
		/// If null is passed, schema validation will not be performed.
		/// </param>
		/// <returns>The loaded Schema instance.</returns>
		public static Schema LoadModelAndDiagram(DslModeling::SerializationResult serializationResult, DslModeling::Store store, string modelFileName, string diagramFileName, DslModeling::ISchemaResolver schemaResolver)
		{
			#region Check Parameters
			if (store == null)
				throw new global::System.ArgumentNullException("store");
			#endregion
			
			return ObjectERSerializationHelper.LoadModelAndDiagram(serializationResult, store.DefaultPartition, modelFileName, store.DefaultPartition, diagramFileName, schemaResolver);
		}
			
		/// <summary>
		/// Loads a Schema instance and its associated diagram file.
		/// </summary>
		/// <param name="serializationResult">Stores serialization result from the load operation.</param>
		/// <param name="modelPartition">Partition in which the new Schema instance will be created.</param>
		/// <param name="modelFileName">Name of the file from which the Schema instance will be deserialized.</param>
		/// <param name="diagramPartition">Partition in which the new ExampleDiagram instance will be created.</param>
		/// <param name="diagramFileName">Name of the file from which the ExampleDiagram instance will be deserialized.</param>
		/// <param name="schemaResolver">
		/// An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).
		/// If null is passed, schema validation will not be performed.
		/// </param>
		/// <returns>The loaded Schema instance.</returns>
		public static Schema LoadModelAndDiagram(DslModeling::SerializationResult serializationResult, DslModeling::Partition modelPartition, string modelFileName, DslModeling::Partition diagramPartition, string diagramFileName, DslModeling::ISchemaResolver schemaResolver)
		{
			#region Check Parameters
			if (serializationResult == null)
				throw new global::System.ArgumentNullException("serializationResult");
			if (modelPartition == null)		
				throw new global::System.ArgumentNullException("modelPartition");
			if (diagramPartition == null)
				throw new global::System.ArgumentNullException("diagramPartition");
			if (string.IsNullOrEmpty(diagramFileName))
				throw new global::System.ArgumentNullException("diagramFileName");
			#endregion
	
			Schema modelRoot;
	
			// Ensure there is an outer transaction spanning both model and diagram load, so moniker resolution works properly.
			if (!diagramPartition.Store.TransactionActive)
			{
				throw new global::System.InvalidOperationException(global::NihonUnisys.ObjectER.ObjectER.SingletonResourceManager.GetString("MissingTransaction"));
			}
	
			modelRoot = ObjectERSerializationHelper.LoadModel(serializationResult, modelPartition, modelFileName, schemaResolver);
	
			if (serializationResult.Failed)
			{
				// don't try to deserialize diagram data if model load failed.
				return modelRoot;
			}
	
			// Set up MonikerResolver for ObjectER.
			ObjectERSerializationHelper.SetupMonikerResolver(diagramPartition.Store);
	
			ExampleDiagram diagram = null;
			DslModeling::DomainClassXmlSerializer diagramSerializer = ObjectERSerializationHelper.Directory.GetSerializer(ExampleDiagram.DomainClassId);
			global::System.Diagnostics.Debug.Assert(diagramSerializer != null, "Cannot find serializer for ExampleDiagram");
			if (diagramSerializer != null)
			{
				if(!global::System.IO.File.Exists(diagramFileName))
				{
					// missing diagram file indicates we should create a new diagram.
					diagram = CreateDiagramHelper(diagramPartition, modelRoot);
				}
				else
				{
					using (global::System.IO.FileStream fileStream = global::System.IO.File.OpenRead(diagramFileName))
					{
						DslModeling::SerializationContext serializationContext = new DslModeling::SerializationContext(ObjectERSerializationHelper.Directory, fileStream.Name, serializationResult);
						
						using (DslModeling::Transaction t = diagramPartition.Store.TransactionManager.BeginTransaction("LoadDiagram", true))
						{
							// Ensure there is some content in the file. Blank (or almost blank, to account for encoding header bytes, etc.)
							// files will cause a new diagram to be created and returned 
							if (fileStream.Length > 5)
							{
								global::System.Xml.XmlReaderSettings settings = new global::System.Xml.XmlReaderSettings();
								try
								{
									using (global::System.Xml.XmlReader reader = global::System.Xml.XmlReader.Create(fileStream, settings))
									{
										reader.MoveToContent();
										diagram = diagramSerializer.TryCreateInstance(serializationContext, reader, diagramPartition) as ExampleDiagram;
										if (diagram != null)
										{
											// Note: the actual instance we get back from TryCreateInstance() can be of a derived type of ExampleDiagram,
											// so we need to find the correct serializer instance to deserialize the element properly.
											DslModeling::DomainClassXmlSerializer instanceSerializer = ObjectERSerializationHelper.Directory.GetSerializer(diagram.GetDomainClass().Id);
											global::System.Diagnostics.Debug.Assert(instanceSerializer != null, "Cannot find serializer for " + diagram.GetDomainClass().Name + "!");
											instanceSerializer.ReadRootElement(serializationContext, diagram, reader, schemaResolver);
										}
									}
								}
								catch (global::System.Xml.XmlException xEx)
								{
									DslModeling::SerializationUtilities.AddMessage(
										serializationContext,
										DslModeling::SerializationMessageKind.Error,
										xEx
									);
								}
								if (serializationResult.Failed)
								{	
									// Serialization error encountered, rollback the transaction.
									diagram = null;
									t.Rollback();
								}
							}
							
							if(diagram == null && !serializationResult.Failed)
							{
								// Create diagram if it doesn't exist
								diagram = CreateDiagramHelper(diagramPartition, modelRoot);
							}
							
							if (t.IsActive)
								t.Commit();
						} // End inner Tx
					}
				}
	
				if (diagram != null)
				{
					diagram.ModelElement = modelRoot;
				}
						
			}
			return modelRoot;
		}
	
		/// <summary>
		/// Helper method to create and initialize a new ExampleDiagram.
		/// </summary>
		[System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA1801:ReviewUnusedParameters", MessageId="modelRoot", Justification = "Signature enforced by caller.")]
		private static global::NihonUnisys.ObjectER.ExampleDiagram CreateDiagramHelper(DslModeling::Partition diagramPartition, DslModeling::ModelElement modelRoot)
		{
			global::NihonUnisys.ObjectER.ExampleDiagram diagram = new global::NihonUnisys.ObjectER.ExampleDiagram(diagramPartition);
			return diagram;
		}
	
		/// <summary>
		/// Saves the given diagram to the given file, with default encoding (UTF-8), and optional properties with default value will not
		/// be written out.
		/// </summary>
		/// <param name="serializationResult">Stores serialization result from the save operation.</param>
		/// <param name="modelRoot">Schema instance to be saved.</param>
		/// <param name="modelFileName">Name of the file in which the CanonicalSampleRoot instance will be saved.</param>
		/// <param name="diagram">ExampleDiagram to be saved.</param>
		/// <param name="diagramFileName">Name of the file in which the diagram will be saved.</param>
		public static void SaveModelAndDiagram(DslModeling::SerializationResult serializationResult, Schema modelRoot, string modelFileName, ExampleDiagram diagram, string diagramFileName)
		{
			ObjectERSerializationHelper.SaveModelAndDiagram(serializationResult, modelRoot, modelFileName, diagram, diagramFileName, global::System.Text.Encoding.UTF8, false);
		}
		
		/// <summary>
		/// Saves the given diagram to the given file, with default encoding (UTF-8).
		/// </summary>
		/// <param name="serializationResult">Stores serialization result from the save operation.</param>
		/// <param name="modelRoot">Schema instance to be saved.</param>
		/// <param name="modelFileName">Name of the file in which the CanonicalSampleRoot instance will be saved.</param>
		/// <param name="diagram">ExampleDiagram to be saved.</param>
		/// <param name="diagramFileName">Name of the file in which the diagram will be saved.</param>
		/// <param name="writeOptionalPropertiesWithDefaultValue">Whether optional properties with default value will be saved.</param>
		public static void SaveModelAndDiagram(DslModeling::SerializationResult serializationResult, Schema modelRoot, string modelFileName, ExampleDiagram diagram, string diagramFileName, bool writeOptionalPropertiesWithDefaultValue)
		{
			ObjectERSerializationHelper.SaveModelAndDiagram(serializationResult, modelRoot, modelFileName, diagram, diagramFileName, global::System.Text.Encoding.UTF8, writeOptionalPropertiesWithDefaultValue);
		}
	
		/// <summary>
		/// Saves the given Schema and ExampleDiagram to the given files, with specified encoding.
		/// </summary>
		/// <param name="serializationResult">Stores serialization result from the save operation.</param>
		/// <param name="modelRoot">Schema instance to be saved.</param>
		/// <param name="modelFileName">Name of the file in which the CanonicalSampleRoot instance will be saved.</param>
		/// <param name="diagram">ExampleDiagram to be saved.</param>
		/// <param name="diagramFileName">Name of the file in which the diagram will be saved.</param>
		/// <param name="encoding">Encoding to use when saving the diagram.</param>
		/// <param name="writeOptionalPropertiesWithDefaultValue">Whether optional properties with default value will be saved.</param>
		[global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters")]
		public static void SaveModelAndDiagram(DslModeling::SerializationResult serializationResult, Schema modelRoot, string modelFileName, ExampleDiagram diagram, string diagramFileName, global::System.Text.Encoding encoding, bool writeOptionalPropertiesWithDefaultValue)
		{
			#region Check Parameters
			if (serializationResult == null)
				throw new global::System.ArgumentNullException("serializationResult");
			if (string.IsNullOrEmpty(modelFileName))
				throw new global::System.ArgumentNullException("modelFileName");
			if (diagram == null)
				throw new global::System.ArgumentNullException("diagram");
			if (string.IsNullOrEmpty(diagramFileName))
				throw new global::System.ArgumentNullException("diagramFileName");
			#endregion
	
			if (serializationResult.Failed)
				return;
	
			// MonikerResolver shouldn't be required in Save operation, so not calling SetupMonikerResolver() here.
	
			// Save the model file first
			using (global::System.IO.MemoryStream modelFileContent = InternalSaveModel(serializationResult, modelRoot, modelFileName, encoding, writeOptionalPropertiesWithDefaultValue))
			{
				if (serializationResult.Failed)
					return;
	
				using (global::System.IO.MemoryStream diagramFileContent = new global::System.IO.MemoryStream())
				{
					DslModeling::DomainClassXmlSerializer diagramSerializer = ObjectERSerializationHelper.Directory.GetSerializer(diagram.GetDomainClass().Id);
					global::System.Diagnostics.Debug.Assert(diagramSerializer != null, "Cannot find serializer for " + diagram.GetDomainClass().Name + "!");
					if (diagramSerializer != null)
					{
						DslModeling::SerializationContext serializationContext = new DslModeling::SerializationContext(ObjectERSerializationHelper.Directory, diagramFileName, serializationResult);
						serializationContext.WriteOptionalPropertiesWithDefaultValue = writeOptionalPropertiesWithDefaultValue;
						global::System.Xml.XmlWriterSettings settings = new global::System.Xml.XmlWriterSettings();
						settings.Indent = true;
						settings.Encoding = encoding;
						using (global::System.IO.StreamWriter streamWriter = new global::System.IO.StreamWriter(diagramFileContent, encoding))
						{
							using (global::System.Xml.XmlWriter writer = global::System.Xml.XmlWriter.Create(streamWriter, settings))
							{
								diagramSerializer.WriteRootElement(serializationContext, diagram, writer);
							}
						}
					}
					if (!serializationResult.Failed)
					{	// Only write the contents if there's no error encountered during serialization.
						if (modelFileContent != null)
						{
							using (global::System.IO.FileStream fileStream = new global::System.IO.FileStream(modelFileName, global::System.IO.FileMode.Create, global::System.IO.FileAccess.Write, global::System.IO.FileShare.None))
							{
								using (global::System.IO.BinaryWriter writer = new global::System.IO.BinaryWriter(fileStream, encoding))
								{
									writer.Write(modelFileContent.ToArray());
								}
							}
						}
						if (diagramFileContent != null)
						{
							using (global::System.IO.FileStream fileStream = new global::System.IO.FileStream(diagramFileName, global::System.IO.FileMode.Create, global::System.IO.FileAccess.Write, global::System.IO.FileShare.None))
							{
								using (global::System.IO.BinaryWriter writer = new global::System.IO.BinaryWriter(fileStream, encoding))
								{
									writer.Write(diagramFileContent.ToArray());
								}
							}
						}
					}
				}
			}
		}
	
		#region Private/Helper Methods/Properties
		/// <summary>
		/// DomainXmlSerializerDirectory instance used by this ObjectERSerializationHelper class.
		/// </summary>
		private static DslModeling::DomainXmlSerializerDirectory directory;
		/// <summary>
		/// DomainXmlSerializerDirectory instance used by this ObjectERSerializationHelper class.
		/// </summary>
		[global::System.Diagnostics.DebuggerBrowsable(global::System.Diagnostics.DebuggerBrowsableState.Never)] // Will trigger creation otherwise.
		private static DslModeling::DomainXmlSerializerDirectory Directory
		{
			[global::System.Diagnostics.DebuggerStepThrough]
			get
			{
				if (ObjectERSerializationHelper.directory == null)
				{
					ObjectERSerializationHelper.directory = new DslModeling::DomainXmlSerializerDirectory();
					directory.AddBehavior(DslDiagrams::CoreDesignSurfaceSerializationBehavior.Instance);
					directory.AddBehavior(ObjectERSerializationBehavior.Instance);
				}
				return ObjectERSerializationHelper.directory;
			}
		}
	
		/// <summary>
		/// Ensure that moniker resolvers are installed properly on the given store, so that deserialization can be carried out correctly.
		/// </summary>
		/// <param name="store">Store on which moniker resolvers will be set up.</param>
		private static void SetupMonikerResolver(DslModeling::Store store)
		{
			if (store.FindMonikerResolver(DslDiagrams::CoreDesignSurface.DomainModelId) == null)
				store.AddMonikerResolver(DslDiagrams::CoreDesignSurface.DomainModelId, new DslDiagrams::CoreDesignSurfaceSerializationBehaviorMonikerResolver(store, ObjectERSerializationHelper.Directory));
			if (store.FindMonikerResolver(ObjectER.DomainModelId) == null)
				store.AddMonikerResolver(ObjectER.DomainModelId, new ObjectERSerializationBehaviorMonikerResolver(store, ObjectERSerializationHelper.Directory));
		}
		#endregion
	}
}
